Subject: Re: SOCK_RAW does not receive broadcast (with VLAN unless PROMISC)

From: Patrick McHardy <[email-masked]>
Date: Tue, 09 Jun 2009 12:59:03 +0200

David Miller wrote:
> From: Gil Beniamini <[email-masked]>
> Date: Mon, 8 Jun 2009 21:05:25 +0300
> 
>> My application is using PF_PACKET and SOCK_RAW in order to receive all
>> Ethernet packets for the machine-unicast MAC plus all broadcast
>> packets (like ARP broadcast).
> 
>> That worked OK with kernel 2.6.20 (Ubuntu 7.04 with or without VLAN).
>>
>> Now with kernel 2.6.28 (Ubuntu 9.04) it works OK only without-VLAN,
>> but with VLAN the application receive only packets for the
>> machine-unicast MAC, but no broadcast (like ARP broadcast) packets,
>> only if I set the socket to PROMISC mode, I start receive also
>> broadcast packets.

Which driver are you using? Are you sniffing on the VLAN device
or on the underlying device?